import 'package:flutter/widgets.dart';

import 'package:bloc_stream/bloc_stream.dart';
import 'bloc_stream_provider.dart';

class BlocStreamBuilder<B extends BlocStream<S>, S> extends StatelessWidget {
  BlocStreamBuilder({
    Key key,
    @required this.builder,
    this.bloc,
  }) : super(key: key);

  final B bloc;
  final AsyncWidgetBuilder<S> builder;

  @override
  Widget build(BuildContext context) {
    final actualBloc = bloc ?? BlocStreamProvider.of<B>(context);

    return StreamBuilder<S>(
      stream: actualBloc.skip(1),
      initialData: actualBloc.value,
      builder: builder,
    );
  }
}
